#
# CMFMonkeyMan
# 
# Based on DiaWebLogBot by David Helder
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
# USA
#
# RMS is a nut.
#

""" Initialize the CMFMonkeyMan Product """

from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory

import MonkeyMan
import MonkeyItem

registerDirectory('skins', globals())

def initialize(context):
    # CMF Initializers
    utils.ContentInit(
        'CMFMonkeyMan Content',
        content_types = (  MonkeyMan.MonkeyMan
                         , MonkeyItem.MonkeyItem
                        ),
        permission = 'Add portal content',
        extra_constructors = (  MonkeyMan.addMonkeyMan
                              , MonkeyItem.addMonkeyItem
                             ),
        fti = ( MonkeyMan.factory_type_information
               , MonkeyItem.factory_type_information
              ),
        ).initialize(context)
        
    utils.registerIcon(MonkeyMan.MonkeyMan,'images/monkeyman_icon.png', globals())
    utils.registerIcon(MonkeyItem.MonkeyItem,'images/monkeyitem_icon.png', globals())
