#!/usr/bin/env python

#
# I've never really worked with XML
# hence the possibly crappiness of this code
#

from xmlrpclib import Server
import xmlrpclib
import httplib
from base64 import encodestring
import string
import time
from xml.sax import saxutils
from xml.sax import make_parser
from xml.sax.handler import feature_namespaces

class BasicAuthTransport(xmlrpclib.Transport):
    """ Provides authentication for xml-rpc clients """
    def __init__(self, username=None, password=None, verbose=0):
        self.verbose=0
        self.username=username
        self.password=password

    def request(self, host, handler, request_body, verbose=0):
        # issue XML-RPC request

        h = httplib.HTTP(host)
        h.putrequest("POST", handler)

        # required by HTTP/1.1
        h.putheader("Host", host)

        # required by XML-RPC
        h.putheader("User-Agent", self.user_agent)
        h.putheader("Content-Type", "text/xml")
        h.putheader("Content-Length", str(len(request_body)))

        # basic auth
        if self.username is not None and self.password is not None:
            h.putheader("AUTHORIZATION", "Basic %s" % string.replace(
                encodestring("%s:%s" % (self.username, self.password)),
                "\012", ""))
        h.endheaders()

        if request_body:
            h.send(request_body)

        errcode, errmsg, headers = h.getreply()

        if errcode != 200:
            raise xmlrpclib.ProtocolError(
                host + handler,
                errcode, errmsg,
                headers
                )

        return self.parse_response(h.getfile())


class ListItems(saxutils.DefaultHandler):
    def __init__(self, mm):
       self.inTitle = 0
       self.inPoster = 0
       self.inDate = 0
       self.inUrl = 0
       self.inText = 0
       self.inItem = 0
       
       self.mm = mm
       self.id = ''
       self.title = ''
       self.url = ''
       self.date = ''
       self.poster = ''
       self.text = ''
       self.hide = 0

    def startElement(self, name, attrs):
       if name == 'item':
          self.id = attrs.get('id', None)
          self.hide = attrs.get('hidden', 0)
          self.inItem = 1
       elif name == 'comment' and self.inItem:
          self.inItem = 0
          
          # post an item
          if self.title == '':
              self.title = self.url             
          print "poster: %s" % self.poster
          print "title: %s" % self.title
          print "url: %s" % self.url
          print "date: %s" % self.date
          print
          self.comment_path = self.mm.addMonkeyItem( self.poster, self.title, self.url, '', int(self.date), 1 )
          time.sleep(1)

          # hide if hidden
          if self.hide:
              self.mm.hideMonkeyItem(self.comment_path)
              
          # zero out, dude
          self.title = ''
          self.url = ''
          self.poster = ''
          self.date = ''          
       elif name == 'title':
          self.inTitle = 1
       elif name == 'poster':
          self.inPoster = 1
       elif name == 'date':
          self.inDate = 1
       elif name == 'url':
          self.inUrl = 1
       elif name == 'text':
          self.inText = 1
       
    def endElement(self, name):
       if name == 'title':
          self.inTitle = 0
       elif name == 'item' and self.inItem:
          self.inItem = 0

          # post an item
          if self.title == '':
              self.title = self.url
          print "poster: %s" % self.poster
          print "title: %s" % self.title
          print "url: %s" % self.url
          print "date: %s" % self.date
          print
          self.comment_path = self.mm.addMonkeyItem( self.poster, self.title, self.url, '', int(self.date), 1 )
          time.sleep(1)
          
          # hide if hidden
          if self.hide:
              self.mm.hideMonkeyItem(self.comment_path)
          # zero out, dude
          self.title = ''
          self.url = ''
          self.poster = ''
          self.date = ''          
       elif name == 'poster':
          self.inPoster = 0
       elif name == 'date':
          self.inDate = 0
       elif name == 'url':
          self.inUrl = 0
       elif name == 'text':
          self.inText = 0
       elif name == 'comment':
          # add a comment
          print "  poster: %s" % self.poster
          print "  date: %s" % int(self.date)
          print "  text: %s" % self.text
          print "  path: %s" % self.comment_path
          print
          self.mm.addComment( self.poster
                            , self.comment_path
                            , self.title
                            , self.text
                            , int(self.date)
                            )
          # zero out, dude
          self.poster = ''
          self.text = ''
          self.date = ''
                    
    def characters(self, ch):
       if self.inTitle:
          self.title = self.title + ch
       elif self.inPoster:
          self.poster = self.poster + ch
       elif self.inDate:
          self.date = self.date + ch
       elif self.inUrl:
          self.url = self.url + ch
       elif self.inText:
          self.text = self.text + ch

def main():
    import sys
    if len(sys.argv) != 5:
        print "Usage: import-dia <diaweb-file-path> <monkeyman-url> <username> <password>"
        sys.exit(1)

    diafile = sys.argv[1]

    trans =  BasicAuthTransport( sys.argv[3], sys.argv[4] )
    mm = Server(sys.argv[2], transport = trans)
    
    parser = make_parser()
    parser.setFeature(feature_namespaces, 0)
    dh = ListItems(mm)
    parser.setContentHandler(dh)
    parser.parse(diafile)

    sys.exit()


if __name__ == "__main__":
    main()
